import { Block } from '@ensi-platform/core-components';
import { useRouter } from 'next/router';
import { useCallback, useMemo } from 'react';

import { useCustomerOrdersMeta } from '@api/customers';
import { Order, useOrdersSearch } from '@api/orders';

import { useError } from '@context/modal';

import { initialSort } from '@views/logistic/pickup-points/[id]/scripts/constants';
import useOrdersAccess from '@views/orders/list/useOrdersAccess';

import LoadWrapper from '@controls/LoadWrapper';

import AutoFilters from '@components/AutoFilters';
import Table, { TooltipItem, TrProps, useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns';
import { RowTooltipWrapper, TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { ITEMS_PER_PRODUCTS_PAGE } from '@scripts/constants';
import { scale } from '@scripts/gds';
import { declOfNum, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';
import { useGoToDetailPage } from '@scripts/hooks/useGoToDetailPage';

export interface OrdersProps {
    customerId: number;
}

const Orders = ({ customerId }: OrdersProps) => {
    const { push, pathname, query } = useRouter();

    const access = useOrdersAccess();

    const { data: metaData, error: metaError } = useCustomerOrdersMeta(!!customerId && access.canViewListingAndFilters);
    const meta = metaData?.data;
    useError(metaError);

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        searchRequestFilter,
        emptyInitialValues,
        codesToSortKeys,
        reset,
        clearInitialValue,
    } = useAutoFilters(meta);

    const [{ backendSorting }, sortingPlugin] = useSorting<Order>(pathname, meta?.fields, initialSort);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        defaultPerPage: ITEMS_PER_PRODUCTS_PAGE,
        codesToSortKeys,
    });

    const {
        data,
        isFetching: isLoading,
        error,
    } = useOrdersSearch(
        {
            sort: backendSorting,
            filter: {
                ...searchRequestFilter,
                customer_id: customerId,
            },
            include: [],
            pagination: { type: 'offset', limit: itemsPerPageCount, offset: (activePage - 1) * itemsPerPageCount },
        },
        Boolean(meta) && !!backendSorting
    );
    useError(error);

    const rows = useAutoTableData<Order>(data?.data, metaField);
    const canViewDetailPage = true;
    const autoGeneratedColumns = useAutoColumns(meta, canViewDetailPage);

    const convertedTableData = useMemo(
        () =>
            rows.map(e => ({
                ...e,
                customListLink: '/orders/list',
            })),
        [rows]
    );

    const total = getTotal(data);
    const totalPages = getTotalPages(data, itemsPerPageCount);
    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const goToDetailPage = useGoToDetailPage({
        pathname: '/orders/list',
        extraConditions: canViewDetailPage,
    });

    const tooltipContent: TooltipItem[] = useMemo(
        () => [
            {
                type: 'edit',
                text: 'Перейти к заказу',
                action: goToDetailPage,
                isDisable: !canViewDetailPage,
            },
        ],
        [canViewDetailPage, goToDetailPage]
    );

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list, tooltipContent }),
        ],
        [autoGeneratedColumns, meta?.default_list]
    );

    const resetFilters = useCallback(() => {
        reset();
        push(
            {
                pathname,
                query: {
                    tab: query.tab,
                    entity_id: query.entity_id,
                },
            },
            undefined,
            {
                scroll: false,
            }
        );
    }, [reset, pathname, push, query.entity_id, query.tab]);

    const renderHeader = useCallback(
        () => (
            <TableHeader>
                <p>Найдено {`${total} ${declOfNum(total, ['заказ', 'заказа', 'заказов'])}`}</p>
            </TableHeader>
        ),
        [total]
    );

    const getTooltipForRow = useCallback(() => tooltipContent || [], [tooltipContent]);
    const renderRow = useCallback(
        ({ children, ...props }: TrProps<any>) => (
            <RowTooltipWrapper
                {...props}
                getTooltipForRow={getTooltipForRow}
                onDoubleClick={() => {
                    if (props.row) goToDetailPage([props.row]);
                }}
            >
                {children}
            </RowTooltipWrapper>
        ),
        [getTooltipForRow, goToDetailPage]
    );

    const table = useTable(
        {
            data: convertedTableData,
            columns,
            meta: {
                tableKey: pathname,
            },
        },
        [sortingPlugin]
    );

    return (
        <Block css={{ borderTopLeftRadius: 0, borderTopRightRadius: 0 }}>
            <Block.Body>
                <LoadWrapper isLoading={isLoading}>
                    <h2>Заказы</h2>
                    <AutoFilters
                        initialValues={values}
                        emptyInitialValues={emptyInitialValues}
                        onSubmit={URLHelper}
                        filtersActive={filtersActive}
                        css={{ marginBottom: scale(2), boxShadow: 'none', padding: 0 }}
                        meta={meta}
                        onResetFilters={resetFilters}
                        clearInitialValue={clearInitialValue}
                        queryPart={{ tab: query.tab }}
                    />
                    {renderHeader()}
                    <Table instance={table} Tr={renderRow} />
                    {convertedTableData.length === 0 && !isLoading ? (
                        <TableEmpty
                            filtersActive={filtersActive}
                            titleWithFilters="Заказы не найдены"
                            titleWithoutFilters="Заказов нет"
                            addItems={() => setItemsPerPageCount(10)}
                            onResetFilters={resetFilters}
                        />
                    ) : (
                        <TableFooter
                            pages={totalPages}
                            itemsPerPageCount={itemsPerPageCount}
                            setItemsPerPageCount={setItemsPerPageCount}
                        />
                    )}
                </LoadWrapper>
            </Block.Body>
        </Block>
    );
};

export default Orders;
